diff --git a/src/http/modules/ngx_http_response_module.c b/src/http/modules/ngx_http_response_module.c
new file mode 100644
index 0000000..5d3fcf6
--- /dev/null
+++ b/src/http/modules/ngx_http_response_module.c
@@ -0,0 +1,266 @@
+
+/*
+ * Copyright (C) Kirill A. Korinskiy
+ */
+
+#include <ngx_config.h>
+#include <ngx_core.h>
+#include <ngx_http.h>
+
+typedef struct {
+  ngx_str_t     response;
+  ngx_array_t  *response_lengths;
+  ngx_array_t  *response_values;
+  ngx_str_t     type;
+} ngx_http_response_conf_t;
+
+static char *ngx_http_response_merge_conf(ngx_conf_t *cf, void *parent, void *child);
+static void *ngx_http_response_create_conf(ngx_conf_t *cf);
+static char *ngx_http_response_set_response_slot(ngx_conf_t *cf, ngx_command_t *cmd,
+						 void *conf);
+
+
+static ngx_command_t  ngx_http_response_commands[] = {
+
+    { ngx_string("response"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
+      ngx_http_response_set_response_slot,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      0,
+      NULL },
+
+    { ngx_string("response_type"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
+      ngx_conf_set_str_slot,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      offsetof(ngx_http_response_conf_t, type),
+      NULL },
+
+    ngx_null_command
+};
+
+
+static ngx_http_module_t  ngx_http_response_module_ctx = {
+    NULL,                          /* preconfiguration */
+    NULL,                          /* postconfiguration */
+
+    NULL,                          /* create main configuration */
+    NULL,                          /* init main configuration */
+
+    NULL,                          /* create server configuration */
+    NULL,                          /* merge server configuration */
+
+    ngx_http_response_create_conf, /* create location configuration */
+    ngx_http_response_merge_conf   /* merge location configuration */
+};
+
+
+ngx_module_t  ngx_http_response_module = {
+    NGX_MODULE_V1,
+    &ngx_http_response_module_ctx, /* module context */
+    ngx_http_response_commands,    /* module directives */
+    NGX_HTTP_MODULE,               /* module type */
+    NULL,                          /* init master */
+    NULL,                          /* init module */
+    NULL,                          /* init process */
+    NULL,                          /* init thread */
+    NULL,                          /* exit thread */
+    NULL,                          /* exit process */
+    NULL,                          /* exit master */
+    NGX_MODULE_V1_PADDING
+};
+
+
+static ngx_int_t
+ngx_http_response_handler(ngx_http_request_t *r)
+{
+    ngx_int_t                     rc;
+    ngx_buf_t                    *b;
+    ngx_str_t                     response;
+    ngx_chain_t                   out;
+    ngx_http_script_code_pt       code;
+    ngx_http_script_engine_t      e;
+    ngx_http_response_conf_t     *conf;
+    ngx_http_core_loc_conf_t     *clcf;
+    ngx_http_script_len_code_pt   lcode;
+
+    conf = ngx_http_get_module_loc_conf(r, ngx_http_response_module);
+
+    if (!conf->response.len) {
+	return NGX_DECLINED;
+    }
+
+    clcf = ngx_http_get_module_loc_conf(r, ngx_http_core_module);
+
+    rc = ngx_http_discard_request_body(r);
+
+    if (rc != NGX_OK) {
+	return rc;
+    }
+
+    if (conf->type.len) {
+	r->headers_out.content_type = conf->type;
+    } else {
+	r->headers_out.content_type = clcf->default_type;
+    }
+
+    if (conf->response_lengths == NULL &&
+	conf->response_values == NULL) {
+	response = conf->response;
+    } else {
+	ngx_memzero(&e, sizeof(ngx_http_script_engine_t));
+	e.ip = conf->response_lengths->elts;
+	e.request = r;
+	e.flushed = 1;
+
+	response.len = 1;		/* 1 byte for terminating '\0' */
+
+	while (*(uintptr_t *) e.ip) {
+	    lcode = *(ngx_http_script_len_code_pt *) e.ip;
+	    response.len += lcode(&e);
+	}
+
+	response.data = ngx_pcalloc(r->pool, response.len);
+	if (response.data == NULL) {
+	    return NGX_ERROR;
+	}
+
+	e.pos = response.data;
+	e.ip = conf->response_values->elts;
+
+	while (*(uintptr_t *) e.ip) {
+	    code = *(ngx_http_script_code_pt *) e.ip;
+	    code((ngx_http_script_engine_t *) &e);
+	}
+
+	response.len = e.pos - response.data;
+    }
+
+    if (r->method == NGX_HTTP_HEAD) {
+	r->headers_out.status = NGX_HTTP_OK;
+	r->headers_out.content_length_n = response.len;
+
+	return ngx_http_send_header(r);
+    }
+
+    b = ngx_pcalloc(r->pool, sizeof(ngx_buf_t));
+    if (b == NULL) {
+	return NGX_ERROR;
+    }
+
+    out.buf = b;
+    out.next = NULL;
+
+    b->pos = response.data;
+    b->last = response.data + response.len;
+    b->memory = 1;
+    b->last_buf = 1;
+
+    r->headers_out.status = NGX_HTTP_OK;
+    r->headers_out.content_length_n = response.len;
+
+    rc = ngx_http_send_header(r);
+
+    if (rc == NGX_ERROR || rc > NGX_OK || r->header_only) {
+	return rc;
+    }
+
+    return ngx_http_output_filter(r, &out);
+}
+
+
+static void *
+ngx_http_response_create_conf(ngx_conf_t *cf)
+{
+    ngx_http_response_conf_t  *conf;
+
+    conf = ngx_pcalloc(cf->pool, sizeof(ngx_http_response_conf_t));
+    if (conf == NULL) {
+	return NGX_CONF_ERROR;
+    }
+
+    /*
+     * set by ngx_pcalloc():
+     *
+     *     conf->before_body = { 0, NULL };
+     *     conf->after_body = { 0, NULL };
+     *     conf->types = { NULL };
+     *     conf->types_keys = NULL;
+     */
+
+    return conf;
+}
+
+
+static char *
+ngx_http_response_merge_conf(ngx_conf_t *cf, void *parent, void *child)
+{
+    ngx_http_response_conf_t *prev = parent;
+    ngx_http_response_conf_t *conf = child;
+
+    if (prev->response.len) {
+	conf->response = prev->response;
+	conf->response_values = prev->response_values;
+	conf->response_lengths = prev->response_lengths;
+    }
+
+    ngx_conf_merge_str_value(conf->type, prev->type, "");
+
+    return NGX_CONF_OK;
+}
+
+static char *
+ngx_http_response_set_response_slot(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
+{
+    ngx_http_core_loc_conf_t   *clcf;
+    ngx_http_response_conf_t   *hrct = conf;
+    ngx_str_t                  *value;
+    ngx_uint_t                  n;
+    ngx_http_script_compile_t   sc;
+
+    clcf = ngx_http_conf_get_module_loc_conf(cf, ngx_http_core_module);
+
+    clcf->handler = ngx_http_response_handler;
+
+    if (hrct->response.data) {
+	return "is duplicate";
+    }
+
+    value = cf->args->elts;
+
+    if (value[1].len == 0) {
+	ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+			   "region \"%V\" in \"%V\" directive is invalid",
+			   &value[1], &value[0]);
+	return NGX_CONF_ERROR;
+    }
+
+    hrct->response = value[1];
+
+    n = ngx_http_script_variables_count(&hrct->response);
+
+    if (n == 0) {
+	return NGX_CONF_OK;
+    }
+
+    ngx_memzero(&sc, sizeof(ngx_http_script_compile_t));
+
+    sc.cf = cf;
+    sc.source = &hrct->response;
+    sc.lengths = &hrct->response_lengths;
+    sc.values = &hrct->response_values;
+    sc.variables = n;
+    sc.complete_lengths = 1;
+    sc.complete_values = 1;
+
+    if (ngx_http_script_compile(&sc) != NGX_OK) {
+	return NGX_CONF_ERROR;
+    }
+
+    return NGX_CONF_OK;
+}
+
+/* Local Variables: */
+/* mode: c */
+/* c-basic-offset: 4 */
+/* End: */
diff --git a/src/http/modules/ngx_http_ssi_filter_module.c b/src/http/modules/ngx_http_ssi_filter_module.c
index d27d854..23c6e66 100644
--- a/src/http/modules/ngx_http_ssi_filter_module.c
+++ b/src/http/modules/ngx_http_ssi_filter_module.c
@@ -73,8 +73,6 @@ static ngx_int_t ngx_http_ssi_output(ngx_http_request_t *r,
     ngx_http_ssi_ctx_t *ctx);
 static ngx_int_t ngx_http_ssi_parse(ngx_http_request_t *r,
     ngx_http_ssi_ctx_t *ctx);
-static ngx_str_t *ngx_http_ssi_get_variable(ngx_http_request_t *r,
-    ngx_str_t *name, ngx_uint_t key);
 static ngx_int_t ngx_http_ssi_evaluate_string(ngx_http_request_t *r,
     ngx_http_ssi_ctx_t *ctx, ngx_str_t *text, ngx_uint_t flags);
 
@@ -82,7 +80,7 @@ static ngx_int_t ngx_http_ssi_include(ngx_http_request_t *r,
     ngx_http_ssi_ctx_t *ctx, ngx_str_t **params);
 static ngx_int_t ngx_http_ssi_stub_output(ngx_http_request_t *r, void *data,
     ngx_int_t rc);
-static ngx_int_t ngx_http_ssi_set_variable(ngx_http_request_t *r, void *data,
+static ngx_int_t ngx_http_ssi_set_included_variable(ngx_http_request_t *r, void *data,
     ngx_int_t rc);
 static ngx_int_t ngx_http_ssi_echo(ngx_http_request_t *r,
     ngx_http_ssi_ctx_t *ctx, ngx_str_t **params);
@@ -90,6 +88,12 @@ static ngx_int_t ngx_http_ssi_config(ngx_http_request_t *r,
     ngx_http_ssi_ctx_t *ctx, ngx_str_t **params);
 static ngx_int_t ngx_http_ssi_set(ngx_http_request_t *r,
     ngx_http_ssi_ctx_t *ctx, ngx_str_t **params);
+static ngx_int_t ngx_http_ssi_for(ngx_http_request_t *r,
+    ngx_http_ssi_ctx_t *ctx, ngx_str_t **params);
+static ngx_int_t ngx_http_ssi_lastfor(ngx_http_request_t *r,
+    ngx_http_ssi_ctx_t *ctx, ngx_str_t **params);
+static ngx_int_t ngx_http_ssi_endfor(ngx_http_request_t *r,
+    ngx_http_ssi_ctx_t *ctx, ngx_str_t **params);
 static ngx_int_t ngx_http_ssi_if(ngx_http_request_t *r,
     ngx_http_ssi_ctx_t *ctx, ngx_str_t **params);
 static ngx_int_t ngx_http_ssi_else(ngx_http_request_t *r,
@@ -224,6 +228,10 @@ static ngx_str_t ngx_http_ssi_null_string = ngx_null_string;
 
 #define  NGX_HTTP_SSI_BLOCK_NAME       0
 
+#define  NGX_HTTP_SSI_FOR_VAR          0
+#define  NGX_HTTP_SSI_FOR_SEP          1
+#define  NGX_HTTP_SSI_FOR_DATA         2
+
 
 static ngx_http_ssi_param_t  ngx_http_ssi_include_params[] = {
     { ngx_string("virtual"), NGX_HTTP_SSI_INCLUDE_VIRTUAL, 0, 0 },
@@ -269,6 +277,14 @@ static ngx_http_ssi_param_t  ngx_http_ssi_block_params[] = {
 };
 
 
+static ngx_http_ssi_param_t  ngx_http_ssi_for_params[] = {
+    { ngx_string("var"), NGX_HTTP_SSI_SET_VAR, 0, 0 },
+    { ngx_string("sep"), NGX_HTTP_SSI_FOR_SEP, 0, 0 },
+    { ngx_string("data"), NGX_HTTP_SSI_FOR_DATA, 1, 0 },
+    { ngx_null_string, 0, 0, 0 }
+};
+
+
 static ngx_http_ssi_param_t  ngx_http_ssi_no_params[] = {
     { ngx_null_string, 0, 0, 0 }
 };
@@ -296,6 +312,10 @@ static ngx_http_ssi_command_t  ngx_http_ssi_commands[] = {
     { ngx_string("endblock"), ngx_http_ssi_endblock,
                        ngx_http_ssi_no_params, 0, 1, 0 },
 
+    { ngx_string("for"), ngx_http_ssi_for, ngx_http_ssi_for_params, 0, 0, 0 },
+    { ngx_string("lastfor"), ngx_http_ssi_lastfor, ngx_http_ssi_no_params, 1, 0, 0 },
+    { ngx_string("endfor"), ngx_http_ssi_endfor, ngx_http_ssi_no_params, 1, 0, 0 },
+
     { ngx_null_string, NULL, NULL, 0, 0, 0 }
 };
 
@@ -360,6 +380,7 @@ ngx_http_ssi_header_filter(ngx_http_request_t *r)
     if (r == r->main) {
         ngx_http_clear_content_length(r);
         ngx_http_clear_last_modified(r);
+        ngx_http_clear_etag(r);
     }
 
     return ngx_http_next_header_filter(r);
@@ -1514,22 +1535,29 @@ ngx_http_ssi_parse(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx)
 }
 
 
-static ngx_str_t *
-ngx_http_ssi_get_variable(ngx_http_request_t *r, ngx_str_t *name,
-    ngx_uint_t key)
+ngx_str_t *
+ngx_http_ssi_get_variable(ngx_http_request_t *r, ngx_str_t *name, ngx_uint_t *key)
 {
     ngx_uint_t           i;
     ngx_list_part_t     *part;
     ngx_http_ssi_var_t  *var;
-    ngx_http_ssi_ctx_t  *ctx;
+    ngx_http_ssi_ctx_t  *mctx;
+
+    if (*key == 0) {
+	*key = ngx_hash_strlow(name->data, name->data, name->len);
+    }
+
+    mctx = ngx_http_get_module_ctx(r->main, ngx_http_ssi_filter_module);
 
-    ctx = ngx_http_get_module_ctx(r->main, ngx_http_ssi_filter_module);
+    if (mctx == NULL) {
+        return NULL;
+    }
 
-    if (ctx->variables == NULL) {
+    if (mctx->variables == NULL) {
         return NULL;
     }
 
-    part = &ctx->variables->part;
+    part = &mctx->variables->part;
     var = part->elts;
 
     for (i = 0; /* void */ ; i++) {
@@ -1548,7 +1576,7 @@ ngx_http_ssi_get_variable(ngx_http_request_t *r, ngx_str_t *name,
             continue;
         }
 
-        if (key != var[i].key) {
+        if (*key != var[i].key) {
             continue;
         }
 
@@ -1560,6 +1588,50 @@ ngx_http_ssi_get_variable(ngx_http_request_t *r, ngx_str_t *name,
     return NULL;
 }
 
+ngx_str_t *
+ngx_http_ssi_set_variable(ngx_http_request_t *r, ngx_str_t *name,
+    ngx_uint_t *key, ngx_str_t *value)
+{
+    ngx_str_t           *vv;
+    ngx_http_ssi_var_t  *var;
+    ngx_http_ssi_ctx_t  *mctx;
+
+    mctx = ngx_http_get_module_ctx(r->main, ngx_http_ssi_filter_module);
+
+    if (mctx == NULL) {
+        return NULL;
+    }
+
+    if (mctx->variables == NULL) {
+        mctx->variables = ngx_list_create(r->main->pool, 4,
+                                          sizeof(ngx_http_ssi_var_t));
+        if (mctx->variables == NULL) {
+            return NULL;
+        }
+    }
+
+    vv = ngx_http_ssi_get_variable(r, name, key);
+    if (vv) {
+        *vv = *value;
+        return vv;
+    }
+
+    if (*key == 0) {
+      *key = ngx_hash_strlow(name->data, name->data, name->len);
+    }
+
+    var = ngx_list_push(mctx->variables);
+    if (var == NULL) {
+        return NULL;
+    }
+
+    var->name = *name;
+    var->key = *key;
+    var->value = *value;
+
+    return &var->value;
+}
+
 
 static ngx_int_t
 ngx_http_ssi_evaluate_string(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
@@ -1568,8 +1640,7 @@ ngx_http_ssi_evaluate_string(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
     u_char                      ch, *p, **value, *data, *part_data;
     size_t                     *size, len, prefix, part_len;
     ngx_str_t                   var, *val;
-    ngx_int_t                   key;
-    ngx_uint_t                  i, n, bracket, quoted;
+    ngx_uint_t                  i, n, bracket, quoted, key = 0;
     ngx_array_t                 lengths, values;
     ngx_http_variable_value_t  *vv;
 
@@ -1695,11 +1766,10 @@ ngx_http_ssi_evaluate_string(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
                 goto invalid_variable;
             }
 
-            key = ngx_hash_strlow(var.data, var.data, var.len);
-
-            val = ngx_http_ssi_get_variable(r, &var, key);
+            val = ngx_http_ssi_get_variable(r, &var, &key);
 
             if (val == NULL) {
+
                 vv = ngx_http_get_variable(r, &var, key,
                                            flags & NGX_HTTP_SSI_EXPR_TEST);
                 if (vv == NULL) {
@@ -1820,13 +1890,12 @@ ngx_http_ssi_include(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
 {
     u_char                      *dst, *src;
     size_t                       len;
-    ngx_int_t                    rc, key;
+    ngx_int_t                    rc;
     ngx_str_t                   *uri, *file, *wait, *set, *stub, args;
     ngx_buf_t                   *b;
-    ngx_uint_t                   flags, i;
+    ngx_uint_t                   flags, i, key;
     ngx_chain_t                 *cl, *tl, **ll, *out;
     ngx_http_request_t          *sr;
-    ngx_http_ssi_var_t          *var;
     ngx_http_ssi_ctx_t          *mctx;
     ngx_http_ssi_block_t        *bl;
     ngx_http_post_subrequest_t  *psr;
@@ -1989,35 +2058,17 @@ ngx_http_ssi_include(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
     }
 
     if (set) {
-        key = ngx_hash_strlow(set->data, set->data, set->len);
-
         psr = ngx_palloc(r->pool, sizeof(ngx_http_post_subrequest_t));
         if (psr == NULL) {
             return NGX_ERROR;
         }
 
-        psr->handler = ngx_http_ssi_set_variable;
-        psr->data = ngx_http_ssi_get_variable(r, set, key);
+        psr->handler = ngx_http_ssi_set_included_variable;
+        psr->data = ngx_http_ssi_get_variable(r, set, &key);
 
         if (psr->data == NULL) {
-
-            if (mctx->variables == NULL) {
-                mctx->variables = ngx_list_create(r->pool, 4,
-                                                  sizeof(ngx_http_ssi_var_t));
-                if (mctx->variables == NULL) {
-                    return NGX_ERROR;
-                }
-            }
-
-            var = ngx_list_push(mctx->variables);
-            if (var == NULL) {
-                return NGX_ERROR;
-            }
-
-            var->name = *set;
-            var->key = key;
-            var->value = ngx_http_ssi_null_string;
-            psr->data = &var->value;
+	  psr->data = ngx_http_ssi_set_variable(r, set, &key,
+						&ngx_http_ssi_null_string);
         }
 
         flags |= NGX_HTTP_SUBREQUEST_IN_MEMORY|NGX_HTTP_SUBREQUEST_WAITED;
@@ -2074,7 +2125,7 @@ ngx_http_ssi_stub_output(ngx_http_request_t *r, void *data, ngx_int_t rc)
 
 
 static ngx_int_t
-ngx_http_ssi_set_variable(ngx_http_request_t *r, void *data, ngx_int_t rc)
+ngx_http_ssi_set_included_variable(ngx_http_request_t *r, void *data, ngx_int_t rc)
 {
     ngx_str_t  *value = data;
 
@@ -2093,9 +2144,9 @@ ngx_http_ssi_echo(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
 {
     u_char                     *p;
     uintptr_t                   len;
-    ngx_int_t                   key;
     ngx_buf_t                  *b;
     ngx_str_t                  *var, *value, *enc, text;
+    ngx_uint_t                  key = 0;
     ngx_chain_t                *cl;
     ngx_http_variable_value_t  *vv;
 
@@ -2104,9 +2155,7 @@ ngx_http_ssi_echo(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
     ngx_log_debug1(NGX_LOG_DEBUG_HTTP, r->connection->log, 0,
                    "ssi echo \"%V\"", var);
 
-    key = ngx_hash_strlow(var->data, var->data, var->len);
-
-    value = ngx_http_ssi_get_variable(r, var, key);
+    value = ngx_http_ssi_get_variable(r, var, &key);
 
     if (value == NULL) {
         vv = ngx_http_get_variable(r, var, key, 1);
@@ -2256,20 +2305,9 @@ static ngx_int_t
 ngx_http_ssi_set(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
     ngx_str_t **params)
 {
-    ngx_int_t            key, rc;
-    ngx_str_t           *name, *value, *vv;
-    ngx_http_ssi_var_t  *var;
-    ngx_http_ssi_ctx_t  *mctx;
-
-    mctx = ngx_http_get_module_ctx(r->main, ngx_http_ssi_filter_module);
-
-    if (mctx->variables == NULL) {
-        mctx->variables = ngx_list_create(r->pool, 4,
-                                          sizeof(ngx_http_ssi_var_t));
-        if (mctx->variables == NULL) {
-            return NGX_ERROR;
-        }
-    }
+    ngx_int_t            rc;
+    ngx_str_t           *name, *value;
+    ngx_uint_t           key;
 
     name = params[NGX_HTTP_SSI_SET_VAR];
     value = params[NGX_HTTP_SSI_SET_VALUE];
@@ -2283,26 +2321,209 @@ ngx_http_ssi_set(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
         return rc;
     }
 
-    key = ngx_hash_strlow(name->data, name->data, name->len);
+    if (ngx_http_ssi_set_variable(r, name, &key, value) == NULL) {
+        return NGX_ERROR;
+    }
 
-    vv = ngx_http_ssi_get_variable(r, name, key);
+    ngx_log_debug2(NGX_LOG_DEBUG_HTTP, r->connection->log, 0,
+                   "set: \"%V\"=\"%V\"", name, value);
 
-    if (vv) {
-        *vv = *value;
+    return NGX_OK;
+}
+
+
+static ngx_int_t ngx_http_ssi_for(ngx_http_request_t *r,
+    ngx_http_ssi_ctx_t *ctx, ngx_str_t **params)
+{
+    u_char                     *p;
+    u_char                     *last;
+    ngx_str_t                   val;
+    ngx_str_t                  *var;
+    ngx_str_t                  *sep;
+    ngx_str_t                  *data;
+    ngx_str_t                  *value;
+    ngx_str_t                   var_default = ngx_string("_");
+    ngx_str_t                   sep_default = ngx_string(" ");
+    ngx_uint_t                  key = 0;
+    ngx_http_variable_value_t  *vv;
+
+    var = params[NGX_HTTP_SSI_FOR_VAR];
+    sep = params[NGX_HTTP_SSI_FOR_SEP];
+    data = params[NGX_HTTP_SSI_FOR_DATA];
+
+    if (data == NULL) {
+        ngx_log_error(NGX_LOG_ERR, r->connection->log, 0,
+                      "no \"data\" parameter in \"for\" SSI command");
+        return NGX_HTTP_SSI_ERROR;
+    }
+
+    if (!sep) {
+        ctx->for_sep.len = sep_default.len;
+        ctx->for_sep.data = ngx_palloc(r->pool, sep_default.len);
+        if (ctx->for_sep.data == NULL) {
+            return NGX_ERROR;
+        }
+        ngx_memcpy(ctx->for_sep.data, sep_default.data, sep_default.len);
+
+        sep = &ctx->for_sep;
+    } else {
+        ctx->for_sep = *sep;
+    }
+
+
+    if (!var) {
+        ctx->for_var.len = var_default.len;
+        ctx->for_var.data = ngx_palloc(r->pool, var_default.len);
+        if (ctx->for_var.data == NULL) {
+            return NGX_ERROR;
+        }
+        ngx_memcpy(ctx->for_var.data, var_default.data, var_default.len);
+
+        var = &ctx->for_var;
+    } else {
+        ctx->for_var = *var;
+    }
+
+    value = ngx_http_ssi_get_variable(r, data, &key);
+
+    if (value == NULL) {
+        vv = ngx_http_get_variable(r, data, key, 1);
+
+        if (vv == NULL) {
+            return NGX_HTTP_SSI_ERROR;
+        }
+
+        if (!vv->not_found) {
+            ctx->for_data.data = vv->data;
+            ctx->for_data.len = vv->len;
+            value = &ctx->for_data;
+        }
+    } else {
+        ctx->for_data = *value;
+    }
+
+
+    if (value == NULL) {
+        ctx->output = 0;
+        ctx->for_data.len = 0;
+        ctx->conditional = 1;
         return NGX_OK;
     }
 
-    var = ngx_list_push(mctx->variables);
-    if (var == NULL) {
+    /* save a parser status */
+    ctx->for_buf = ctx->buf;
+    ctx->for_pos = ctx->pos;
+    ctx->for_copy_start = ctx->copy_start;
+    ctx->for_copy_end = ctx->copy_end;
+    ctx->for_state = ctx->state;
+    ctx->for_looked = ctx->looked;
+    ctx->have_last_for = 0;
+
+    ctx->output = 1;
+    ctx->conditional = 1;
+
+    key = 0;
+
+    if (ngx_http_ssi_set_variable(r, &ctx->for_var, &key, &ctx->for_data) == NULL) {
         return NGX_ERROR;
     }
 
-    var->name = *name;
-    var->key = key;
-    var->value = *value;
+    for (p = ctx->for_data.data, last = p + ctx->for_data.len - ctx->for_sep.len;
+         p <= last; p++) {
+        if (ngx_strncmp(p, ctx->for_sep.data, ctx->for_sep.len) == 0) {
+            val.data = ctx->for_data.data;
+            val.len = p - val.data;
+
+            ctx->for_data.data = val.data + val.len + ctx->for_sep.len;
+            ctx->for_data.len = ctx->for_data.len - val.len - ctx->for_sep.len;
+
+            key = 0;
+            if (ngx_http_ssi_set_variable(r, &ctx->for_var, &key, &val) == NULL) {
+                return NGX_ERROR;
+            }
+
+            return NGX_OK;
+        }
+    }
+
+    ctx->for_data.len = 0;
+
+    return NGX_OK;
+}
+
+static ngx_int_t
+ngx_http_ssi_lastfor(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
+    ngx_str_t **params)
+{
+    ctx->have_last_for = 1;
+
+    if (ctx->for_data.len == 0) {
+        ctx->output = 1;
+    } else {
+        ctx->output = 0;
+    }
+
+    return NGX_OK;
+}
+
+static ngx_int_t
+ngx_http_ssi_endfor(ngx_http_request_t *r, ngx_http_ssi_ctx_t *ctx,
+    ngx_str_t **params)
+{
+    u_char                     *p;
+    u_char                     *last;
+    ngx_str_t                   val;
+    ngx_uint_t                  key = 0;
+
+    if (ctx->for_data.len == 0) {
+        ctx->output = 1;
+        ctx->conditional = 0;
+        return NGX_OK;
+    }
+
+    for (p = ctx->for_data.data, last = p + ctx->for_data.len - ctx->for_sep.len;
+         p < last; p++) {
+        if (ngx_strncmp(p, ctx->for_sep.data, ctx->for_sep.len) == 0) {
+            val.data = ctx->for_data.data;
+            val.len = p - val.data;
+
+            ctx->for_data.data = val.data + val.len + ctx->for_sep.len;
+            ctx->for_data.len = ctx->for_data.len - val.len - ctx->for_sep.len;
+
+            key = 0;
+            if (ngx_http_ssi_set_variable(r, &ctx->for_var, &key, &val) == NULL) {
+                return NGX_ERROR;
+            }
+
+            break;
+        }
+    }
+
+    if (p == last) {
+        val = ctx->for_data;
+        if (ngx_strncmp(p, ctx->for_sep.data, ctx->for_sep.len) == 0) {
+            val.len -= ctx->for_sep.len;
+        }
+        if (ngx_http_ssi_set_variable(r, &ctx->for_var, &key, &val) == NULL) {
+            return NGX_ERROR;
+        }
+
+        ctx->for_data.len = 0;
+        if (ctx->have_last_for) {
+            ctx->output = 0;
+        }
+    } else {
+        ctx->output = 1;
+    }
+
+    /* revert back saved parser status */
+    ctx->buf = ctx->for_buf;
+    ctx->pos = ctx->for_pos;
+    ctx->copy_start = ctx->for_copy_start;
+    ctx->copy_end = ctx->for_copy_end;
+    ctx->state = ctx->for_state;
+    ctx->looked = ctx->for_looked;
 
-    ngx_log_debug2(NGX_LOG_DEBUG_HTTP, r->connection->log, 0,
-                   "set: \"%V\"=\"%V\"", name, value);
 
     return NGX_OK;
 }
@@ -2794,3 +3015,10 @@ ngx_http_ssi_filter_init(ngx_conf_t *cf)
 
     return NGX_OK;
 }
+
+/* Local Variables: */
+/* mode: c */
+/* c-basic-offset: 4 */
+/* c-file-offsets: ((arglist-cont-nonempty . 4)) */
+/* indent-tabs-mode: nil */
+/* End: */
diff --git a/src/http/modules/ngx_http_ssi_filter_module.h b/src/http/modules/ngx_http_ssi_filter_module.h
index 6ab1884..e73d53f 100644
--- a/src/http/modules/ngx_http_ssi_filter_module.h
+++ b/src/http/modules/ngx_http_ssi_filter_module.h
@@ -64,6 +64,19 @@ typedef struct {
     ngx_list_t               *variables;
     ngx_array_t              *blocks;
 
+    /* for hacks */
+    ngx_buf_t                *for_buf;
+    u_char                   *for_pos;
+    u_char                   *for_copy_start;
+    u_char                   *for_copy_end;
+    ngx_uint_t                for_state;
+    size_t                    for_looked;
+    ngx_flag_t                have_last_for;
+
+    ngx_str_t                 for_data;
+    ngx_str_t                 for_sep;
+    ngx_str_t                 for_var;
+
     unsigned                  conditional:2;
     unsigned                  encoding:2;
     unsigned                  block:1;
@@ -103,5 +116,16 @@ typedef struct {
 
 extern ngx_module_t  ngx_http_ssi_filter_module;
 
+ngx_str_t *ngx_http_ssi_get_variable(ngx_http_request_t *r, ngx_str_t *name,
+    ngx_uint_t *key);
+ngx_str_t *ngx_http_ssi_set_variable(ngx_http_request_t *r, ngx_str_t *name,
+    ngx_uint_t *key, ngx_str_t *value);
 
 #endif /* _NGX_HTTP_SSI_FILTER_H_INCLUDED_ */
+
+/* Local Variables: */
+/* mode: c */
+/* c-basic-offset: 4 */
+/* c-file-offsets: ((arglist-cont-nonempty . 4)) */
+/* indent-tabs-mode: nil */
+/* End: */
diff --git a/src/http/modules/ngx_http_static_module.c b/src/http/modules/ngx_http_static_module.c
index bc46b84..32d835c 100644
--- a/src/http/modules/ngx_http_static_module.c
+++ b/src/http/modules/ngx_http_static_module.c
@@ -212,6 +212,10 @@ ngx_http_static_handler(ngx_http_request_t *r)
     r->headers_out.content_length_n = of.size;
     r->headers_out.last_modified_time = of.mtime;
 
+    r->headers_out.etag_size = of.size;
+    r->headers_out.etag_time = of.mtime;
+    r->headers_out.etag_uniq = of.uniq;
+
     if (ngx_http_set_content_type(r) != NGX_OK) {
         return NGX_HTTP_INTERNAL_SERVER_ERROR;
     }
diff --git a/src/http/modules/ngx_http_stub_status_module.c b/src/http/modules/ngx_http_stub_status_module.c
index 9d2d074..eac479c 100644
--- a/src/http/modules/ngx_http_stub_status_module.c
+++ b/src/http/modules/ngx_http_stub_status_module.c
@@ -63,7 +63,7 @@ static ngx_int_t ngx_http_status_handler(ngx_http_request_t *r)
     ngx_int_t          rc;
     ngx_buf_t         *b;
     ngx_chain_t        out;
-    ngx_atomic_int_t   ap, hn, ac, rq, rd, wr;
+    ngx_atomic_int_t   ap, hn, ac, rq, rd, wr, rp;
 
     if (r->method != NGX_HTTP_GET && r->method != NGX_HTTP_HEAD) {
         return NGX_HTTP_NOT_ALLOWED;
@@ -91,7 +91,8 @@ static ngx_int_t ngx_http_status_handler(ngx_http_request_t *r)
     size = sizeof("Active connections:  \n") + NGX_ATOMIC_T_LEN
            + sizeof("server accepts handled requests\n") - 1
            + 6 + 3 * NGX_ATOMIC_T_LEN
-           + sizeof("Reading:  Writing:  Waiting:  \n") + 3 * NGX_ATOMIC_T_LEN;
+           + sizeof("Reading:  Writing:  Waiting:  \n") + 3 * NGX_ATOMIC_T_LEN
+           + sizeof("Request/sec:  \n") + NGX_ATOMIC_T_LEN;
 
     b = ngx_create_temp_buf(r->pool, size);
     if (b == NULL) {
@@ -107,6 +108,7 @@ static ngx_int_t ngx_http_status_handler(ngx_http_request_t *r)
     rq = *ngx_stat_requests;
     rd = *ngx_stat_reading;
     wr = *ngx_stat_writing;
+    rp = *ngx_stat_requests_per_seconds;
 
     b->last = ngx_sprintf(b->last, "Active connections: %uA \n", ac);
 
@@ -117,6 +119,8 @@ static ngx_int_t ngx_http_status_handler(ngx_http_request_t *r)
 
     b->last = ngx_sprintf(b->last, "Reading: %uA Writing: %uA Waiting: %uA \n",
                           rd, wr, ac - (rd + wr));
+    b->last = ngx_sprintf(b->last, "Request/sec: %uA \n",
+                          rp);
 
     r->headers_out.status = NGX_HTTP_OK;
     r->headers_out.content_length_n = b->last - b->pos;
diff --git a/src/http/modules/ngx_http_sub_filter_module.c b/src/http/modules/ngx_http_sub_filter_module.c
index 34f3294..2660577 100644
--- a/src/http/modules/ngx_http_sub_filter_module.c
+++ b/src/http/modules/ngx_http_sub_filter_module.c
@@ -157,6 +157,7 @@ ngx_http_sub_header_filter(ngx_http_request_t *r)
     if (r == r->main) {
         ngx_http_clear_content_length(r);
         ngx_http_clear_last_modified(r);
+        ngx_http_clear_etag(r);
     }
 
     return ngx_http_next_header_filter(r);
diff --git a/src/http/modules/ngx_http_upstream_ip_hash_module.c b/src/http/modules/ngx_http_upstream_ip_hash_module.c
index dffbf22..f33390b 100644
--- a/src/http/modules/ngx_http_upstream_ip_hash_module.c
+++ b/src/http/modules/ngx_http_upstream_ip_hash_module.c
@@ -101,6 +101,9 @@ ngx_http_upstream_init_ip_hash_peer(ngx_http_request_t *r,
         return NGX_ERROR;
     }
 
+    iphp->rrp.u = r->upstream;
+    iphp->rrp.peers_is_backup = 0;
+
     r->upstream->peer.data = &iphp->rrp;
 
     if (ngx_http_upstream_init_round_robin_peer(r, us) != NGX_OK) {
diff --git a/src/http/modules/ngx_http_userid_filter_module.c b/src/http/modules/ngx_http_userid_filter_module.c
index 5ffb1d0..270b70a 100644
--- a/src/http/modules/ngx_http_userid_filter_module.c
+++ b/src/http/modules/ngx_http_userid_filter_module.c
@@ -770,7 +770,7 @@ ngx_http_userid_mark(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
 static ngx_int_t
 ngx_http_userid_init_worker(ngx_cycle_t *cycle)
 {
-    struct timeval  tp;
+    ngx_timeval_t  tp;
 
     ngx_gettimeofday(&tp);
 
diff --git a/src/http/modules/ngx_http_xslt_filter_module.c b/src/http/modules/ngx_http_xslt_filter_module.c
index 220400c..e966498 100644
--- a/src/http/modules/ngx_http_xslt_filter_module.c
+++ b/src/http/modules/ngx_http_xslt_filter_module.c
@@ -340,6 +340,7 @@ ngx_http_xslt_send(ngx_http_request_t *r, ngx_http_xslt_filter_ctx_t *ctx,
         }
 
         ngx_http_clear_last_modified(r);
+        ngx_http_clear_etag(r);
     }
 
     rc = ngx_http_next_header_filter(r);
diff --git a/src/http/modules/perl/nginx.pm b/src/http/modules/perl/nginx.pm
index 6643c48..d33068e 100644
--- a/src/http/modules/perl/nginx.pm
+++ b/src/http/modules/perl/nginx.pm
@@ -47,7 +47,7 @@ our @EXPORT = qw(
     HTTP_INSUFFICIENT_STORAGE
 );
 
-our $VERSION = '0.7.57';
+our $VERSION = '0.7.57.422.152eb14'
 
 require XSLoader;
 XSLoader::load('nginx', $VERSION);
